import { useState } from 'react';

import '../assets/style/displayController.css';

import PersonListing from './personListing.component.jsx';
import DelayButton from './delayButton.component.jsx';

const PersonListingController = ({ initialDelay = 250 }) => {

    const [ closed, setClosed ] = useState(false);
    const [ started, setStarted ] = useState(false);
    const [ delay, setDelay ] = useState(initialDelay)

    const startStop = () => setStarted( previousStarted => ! previousStarted);
    const closeComponent = () => setClosed(true);

    const changeDelay = newDelay => setDelay(newDelay);

    const buildDelayButtons = ()  => {
        const delayButtons = [250, 1000, 3000].map(delay => <DelayButton delay={delay}
                                                                         changeDelay={changeDelay}
                                                                         key={delay} />);
        return delayButtons;
     }

    if (closed)
        return null;
    // else
    return (
            <div>
                <div className = 'controller'>
                    <button onClick= { startStop }>
                        { started ? 'Stop' : 'Start'}
                    </button>
                    { buildDelayButtons() }
                </div>
                <PersonListing
                    delay = { delay }
                    started = { started }
                />
            </div>
        );

}

export default PersonListingController;